Subject: Re: bug#71435: interactive xref-find-definitions-at-mouse

From: Alan Donovan <[email-masked]>
Date: Mon, 10 Jun 2024 13:26:59 -0400

I can reliably reproduce the problem using this script:

;; reproducer for use in emacs -Q:
;; invoke load-file on this file,
;; then follow the interactive steps at the very end.

(emacs-version) ; 29.3
(require 'eglot) ; 1.17.0

;; --- these steps are documented at
;;
https://github.com/golang/tools/blob/master/gopls/doc/emacs.md#configuring-project-for-go-modules-in-emacs

(require 'project) ; 0.11.0

(defun project-find-go-module (dir)
  (when-let ((root (locate-dominating-file dir "go.mod")))
    (cons 'go-module root)))

(cl-defmethod project-root ((project (head go-module)))
  (cdr project))

(add-hook 'project-find-functions #'project-find-go-module)
;; -----

; Use your favorite modifier; s is super, aka ⌘ key on Mac.
(global-set-key (kbd "s-<mouse-1>") #'xref-find-definitions-at-mouse)

;; This file comes from github.com/dominikh/go-mode.el@master.
(load-file "~/w/go-mode.el/go-mode.el")

;; Create a new Go buffer.
(with-current-buffer (find-file "/tmp/a.go")
  (eglot-ensure)
  (insert "package main\n\nimport \"fmt\"\n\nfunc main()
{\n\tfmt.Println()\n}\n")
  (set-buffer (current-buffer)))

;; You should now be in a Go buffer in go-mode with eglot enabled.
;;
;; Now: position the point in "fmt", and then ⌘-click on "Println".
;; For me, Emacs navigates to the declaration of "fmt", not "Println".
;; The converse is true as well: with the point in Println,
;; a ⌘-click on fmt goes to the declaration of Println.

On Mon, 10 Jun 2024 at 11:23, Eli Zaretskii <[email-masked]> wrote:

> > From: Alan Donovan <[email-masked]>
> > Date: Mon, 10 Jun 2024 10:39:04 -0400
> > Cc: Juri Linkov <[email-masked]>, Stefan Kangas <[email-masked]>,
>
> >       Eli Zaretskii <[email-masked]>, [email-masked]
> >
> > > ?? This works for me:
> > >  (global-set-key [C-down-mouse-1] 'xref-find-definitions-at-mouse)
> >
> > Ah, I remember the problem now: if the point is at position A and the
> mouse click occurs at some unrelated
> > position B, plain old xref-find-definitions-at-mouse will use position A
> as the basis of the query
>
> I cannot reproduce thus.  I just tried, and the mouse click shows the
> definition of identifier at mouse click, not at point.
>
> > So perhaps my request should instead have been expressed as a bug
> report: xref-find-definitions-at-mouse
> > uses the point instead of the mouse event position.
>
> Please show a recipe for reproducing this, and please also tell what
> version of Emacs are you using and on which platform.
>
> Thanks.
>